package rocks.zipcode.io.quiz3.fundamentals;

import static rocks.zipcode.io.quiz3.fundamentals.VowelUtils.getIndexOfFirstVowel;
import static rocks.zipcode.io.quiz3.fundamentals.VowelUtils.hasVowels;
import static rocks.zipcode.io.quiz3.fundamentals.VowelUtils.startsWithVowel;

/**
 * @author leon on 09/12/2018.
 */
public class PigLatinGenerator {
    public String translate(String str) {
        StringBuilder sb = new StringBuilder();
        for (String word : str.split(" ")) {
            sb.append(transform1(word));
            sb.append(transform2(word));
            sb.append(" ");
        }
        return sb.toString().replaceAll(" $", "");
    }

    private String transform2(String word) {
        if (word == null || startsWithVowel(word)) {
            return "";
        }
        Integer firstIndexOfVowel = hasVowels(word) ? getIndexOfFirstVowel(word) : word.length();
        String suffix = word.substring(0, firstIndexOfVowel);
        String prefix = word.substring(firstIndexOfVowel, word.length());
        return prefix + suffix + "ay";
    }

    private String transform1(String word) {
        if (startsWithVowel(word)) {
            return word.concat("way");
        }
        return "";
    }

}
