package rocks.zipcode.io.quiz3.fundamentals.wavegenerator;

import org.junit.Assert;
import org.junit.Test;
import rocks.zipcode.io.quiz3.arrays.WaveGenerator;

import java.util.Arrays;
import java.util.function.Function;

/**
 * @author leon on 09/12/2018.
 */
public class WaveTest {
    @Test
    public void basicTest1() {
        String stringToPermutate = "hello";
        String[] input = new String[] { "Hello", "hEllo", "heLlo", "helLo", "hellO" };
        evaluate(stringToPermutate, input, WaveGenerator::wave);
    }

    @Test
    public void basicTest2() {
        String stringToPermutate = "codewars";
        String[] result = new String[] { "Codewars", "cOdewars", "coDewars", "codEwars", "codeWars", "codewArs", "codewaRs", "codewarS" };
        evaluate(stringToPermutate, result, WaveGenerator::wave);
    }

    @Test
    public void basicTest3() {
        String stringToPermutate = "";
        String[] result = new String[] { };
        evaluate(stringToPermutate, result, WaveGenerator::wave);
    }

    @Test
    public void basicTest4() {
        String stringToPermutate = "two words";
        String[] result = new String[] { "Two words", "tWo words", "twO words", "two Words", "two wOrds", "two woRds", "two worDs", "two wordS" };
        evaluate(stringToPermutate, result, WaveGenerator::wave);
    }

    @Test
    public void basicTest5() {
        String stringToPermutate = " gap ";
        String[] result = new String[] { " Gap ", " gAp ", " gaP " };
        evaluate(stringToPermutate, result, WaveGenerator::wave);
    }

    public void evaluate(String stringToPermutate, String[] expected, Function<String, String[]> waveFunction) {
        String[] actual = waveFunction.apply(stringToPermutate);
        String actualStr = Arrays.toString(actual);
        String expectedStr = Arrays.toString(expected);
        Assert.assertEquals(expectedStr, actualStr);
    }
}
